
Public Class Form1
    Public t1 As Integer  ' used for timer
    Public textIn As String ' global text in
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        CheckForIllegalCrossThreadCalls = False

        Populate_Ports()
        Timer1.Enabled = True
        Timer1.Interval = 10 ' 10 ms
        t1 = 0 ' this will roll over after 490 days

        ' Load Speed Settings
        cboSpeed.Items.Add("110")
        cboSpeed.Items.Add("300")
        cboSpeed.Items.Add("600")
        cboSpeed.Items.Add("1200")
        cboSpeed.Items.Add("2400")
        cboSpeed.Items.Add("4800")
        cboSpeed.Items.Add("9600")
        cboSpeed.Items.Add("14400")
        cboSpeed.Items.Add("19200")
        cboSpeed.Items.Add("28800")
        cboSpeed.Items.Add("38400")
        cboSpeed.Items.Add("56000")
        cboSpeed.Items.Add("57600")
        cboSpeed.Items.Add("115200")
        cboSpeed.Items.Add("128000")
        cboSpeed.Items.Add("256000")
        cboSpeed.SelectedIndex = 10
        cboPort.SelectedIndex = 0
        cmdOpen.Enabled = False
    End Sub

    Private Sub cmdOpen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdOpen.Click
        If port1.IsOpen Then
            cmdOpen.Text = "Closed"
            cmdOpen.BackColor = Color.LightGray
            port1.Close()
            panSystem.Enabled = False
            cmdNon.Enabled = False
        Else
            port1.BaudRate = cboSpeed.Items(cboSpeed.SelectedIndex)
            port1.PortName = cboPort.Items(cboPort.SelectedIndex)
            port1.Open()
            cmdOpen.Text = "Open"
            cmdOpen.BackColor = Color.LightGreen
            '            panSystem.Enabled = True
            cmdNon.Enabled = True
        End If
    End Sub
    Private Sub Populate_Ports()
        ' Get a list of serial port names.
        Dim ports As String() = port1.GetPortNames()

        ' Display each port name to the console.
        cboPort.Items.Clear()
        Dim port As String
        For Each port In ports
            cboPort.Items.Add(port)
            Console.WriteLine(port)
        Next port

    End Sub

    ' gets all port names in system and puts them in the combo box
    Private Sub Label1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Label1.Click
        Populate_Ports()
    End Sub

    ' Output to serial port and waits for ACK so only use on commands
    ' that send ack back
    Public Sub Data(ByVal t)
        textIn = "" ' clear buffer
        port1.Write(t)
        GetAck(t, ">") ' reports error if not found
    End Sub

    ' sends plain text
    Sub Send(ByVal s As String)
        port1.Write(s)
        Cmd("[e")   ' invoke ack
    End Sub

    ' Sends command and waits for ACK which is '>'
    Public Sub Cmd(ByVal s As String)
        port1.Write(Chr(27)) ' escape
        Data(s) ' command
    End Sub

    ' Data recieved into a program buffer (textIn)
    Private Sub port1_DataReceived(ByVal sender As System.Object, ByVal e As System.IO.Ports.SerialDataReceivedEventArgs) Handles port1.DataReceived
        textIn = textIn + port1.ReadExisting
    End Sub

    Private Sub cmdNon_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdNon.Click
        textIn = "" ' clear buffer
        txtNon.Text = "Wait..."
        editHelp.Text = ""    ' clear info screen
        If Connect() = 1 Then
            panSystem.Enabled = True
            cmdNon.Enabled = True
        End If
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        t1 = t1 + 1 ' update every 10 ms when enabled
    End Sub

    Private Sub Label1_MouseHover(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Label1.MouseHover
        ToolTip.SetToolTip(Label1, "Click to refresh port list")
    End Sub

    Private Sub cmdSend_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdSend.Click
        Cmd(txtSendCmd.Text)
    End Sub

    Private Sub cmdData_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdData.Click
        port1.Write(txtSendData.Text)
    End Sub

    Private Sub d_time()
        Cmd("(3")   ' large font
        Cmd("{120,2p") ' pixel place
        Send(TimeOfDay)
    End Sub

    ' draws a bar with markers every 10
    Private Sub d_bar(ByVal left, ByVal top, ByVal length)
        Dim s, j
        s = "{" + Trim$((Str$(left))) + Str$(top) + Str$(length + left) + Str$(top + 10) + "R"
        ' MsgBox(s)
        ' draws box
        Cmd(s)
        ' draws marker lines at 10
        For j = left To left + length Step 10
            Cmd("{" + Trim$((Str$(j))) + Str$(top) + Str$(j) + Str$(top + 3) + "L")
            Cmd("{" + Trim$((Str$(j))) + Str$(top + 7) + Str$(j) + Str$(top + 10) + "L")
        Next
    End Sub
    Private Sub d_barV(ByVal left, ByVal top, ByVal length, ByVal v)
        ' draw filled with colour
        Cmd("{" + Trim$((Str$(left))) + Str$(top + 4) + Str$(left + v) + Str$(top + 7) + "F")
        ' invert colour
        Cmd("[I")
        ' rest of line to blank out with inverted
        Cmd("{" + Trim$((Str$(left + v))) + Str$(top + 4) + Str$(length) + Str$(top + 7) + "F")
        ' put back
        Cmd("[I")
    End Sub

    Private Sub d_spectrumG(ByVal left, ByVal top, ByVal length)
        Dim j
        ' draws spwcrum graticlue
        Cmd("{" + Trim$((Str$(left))) + Str$(top) + Str$(left + length) + Str$(top + 25) + "R")
        ' draws scale mark at bottom
        For j = left To left + length - 5 Step 10
            Cmd("{" + Trim$((Str$(j))) + Str$(top + 20) + Str$(j + 5) + Str$(top + 25) + "F")
        Next
        Cmd("{" + Trim$((Str$(left))) + Str$(top + 20) + Str$(left + length) + Str$(top + 20) + "L")
    End Sub
    Private Sub d_spectrumF(ByVal left, ByVal top, ByVal length, ByVal f, ByVal v)
        ' frequency and value
        ' clear rctangle
        Cmd("[I")
        Cmd("{" + Trim$((Str$(left + 1))) + Str$(top + 1) + Str$(left + length - 1) + Str$(top + 19) + "F")
        Cmd("[I")
        Cmd("{" + Trim$((Str$(left + f))) + Str$(top + 20) + Str$(left + f) + Str$(top + 20 - v) + "L")
    End Sub
    Private Sub d_spectrumS(ByVal left, ByVal top, ByVal length)
        Dim j, v
        ' clear rctangle
        Cmd("[I")
        Cmd("{" + Trim$((Str$(left + 1))) + Str$(top + 1) + Str$(left + length - 1) + Str$(top + 19) + "F")
        Cmd("[I")
        For j = 1 To 80
            v = CInt(Math.Floor((20 - 1 + 1) * Rnd())) + 1
            Cmd("{" + Trim$((Str$(left + j))) + Str$(top + v) + "P")
        Next
    End Sub
    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdDemo.Click
        Dim j, v, f
        Cmd("[3J")  ' clear screen
        Cmd("[?25I")    ' cursor off
        Cmd("{119,1,189,18R") ' rectangle top right
        d_time() ' time in rectangle
        ' bars
        Cmd("[0;0H")
        Send("-- Engine --")
        Cmd("(2")
        Cmd("[2;3H")
        Send("Running")
        Cmd("(1")
        Cmd("{5,32p")
        Send("VAC")
        d_bar(25, 30, 60)
        d_barV(25, 30, 60, 12)
        Cmd("{6,42p")
        Send("PSI")
        d_bar(25, 40, 60)
        d_barV(25, 40, 60, 42)
        Cmd("{6,52p")
        Send("ING")
        d_bar(25, 50, 60)
        d_barV(25, 50, 60, 27)
        ' list
        Cmd("{155,20p")
        Send("ON/OFF")
        Cmd("{110,28p")
        Send("Logging")
        Cmd("{157,30,161,34F")
        Cmd("{126,37p")
        Send("Data")
        Cmd("{173,38,177,43R")
        Cmd("{126,46p")
        Send("Time")
        Cmd("{157,46,161,50F")
    End Sub

    Private Sub cboPort_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboPort.SelectedIndexChanged
        If cboPort.Text <> "" Then
            cmdOpen.Enabled = True
        End If
    End Sub
End Class
